// C Source File created by Scott Little
// Email comments and improvments to: scott_little@tayloru.edu
// Created 1/9/02; 11:31:58 AM


#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files


// Main Function

void _main(void)
{
	static short int A[36][36]; //create a 36 by 36 "matrix" (array of arrays)
	static short int B[36][36];
	int s = 0;
	int n = 0;
	int x = 0;
	int y = 0;
	int xx = 18;
	int yy = 18;
	int key = 0;
	randomize();  //seed the randomizer
	for(y=1;y<36;y++){
		for(x=1;x<36;x++){
			A[y][x] = random(2); //pick either 0 or 1 and put it in A
		}
	}
	for(y=0;y<100;y++){
		for(x=0;x<160;x++){
			DrawPix(x,y,A_NORMAL);  //make the whole screen black
		}
	}
	DrawStr(5,78,"Use arrow keys to move   ",A_XOR);
 	DrawStr(5,86,"& press F1 to place a dot",A_XOR);
 	
 	FontSetSys(F_8x10);  
	DrawStr(76,04,"Game",A_XOR);
	DrawStr(76,14,"    of",A_XOR);
	DrawStr(76,24,"      Life",A_XOR);
	FontSetSys(F_4x6);
	DrawStr(90,44,"By Scott Little",A_XOR);
	DrawStr(80,60,"Email: scott_little@",A_XOR);
	DrawStr(102,65,"tayloru.edu",A_XOR);
	

	
	while (key!=KEY_ESC){  					//the main loop of the program
		if (kbhit()){									//key controls
			key = ngetchx();
			if (key==KEY_UP)(yy--);          
			if (key==KEY_DOWN)(yy++);
			if (key==KEY_RIGHT)(xx++);
			if (key==KEY_LEFT)(xx--);
			if (key==KEY_F1)(A[yy][xx]=1);
		} 
		else{
			key = 0;
		}

		
		DrawPix(2*xx,2*yy,A_NORMAL);				//these 4 lines draw the cursor dot
		DrawPix(2*xx+1,2*yy,A_NORMAL);
		DrawPix(2*xx,2*yy+1,A_NORMAL);
		DrawPix(2*xx+1,2*yy+1,A_NORMAL);
		
		
		for(y=1;y<36;y++){                   //brain of program see read me
			for(x=1;x<36;x++){
				n = A[y][x];
				s = A[y-1][x+1]+A[y-1][x]+A[y-1][x-1]+
						A[y][x+1]+A[y][x-1]+
						A[y+1][x+1]+A[y+1][x]+A[y+1][x-1];
				if (n==1 && s==2)(B[y][x] = 1);  //next 2 lines: after applying rules to A store to B
				if (s==3)(B[y][x] = 1);
			}	
		}		
		for(y=1;y<36;y++){                   //these 2 for loops draw either a dot or a nondot
			for(x=1;x<36;x++){
				if (B[y][x]==1){
					DrawPix(2*x,2*y,A_NORMAL);     //these 4 lines draw one dot
					DrawPix(2*x+1,2*y,A_NORMAL);
					DrawPix(2*x,2*y+1,A_NORMAL);
					DrawPix(2*x+1,2*y+1,A_NORMAL);
					
				}
				else {
					DrawPix(2*x,2*y,A_REVERSE);  //these 4 lines erase one dot
					DrawPix(2*x+1,2*y,A_REVERSE);
					DrawPix(2*x,2*y+1,A_REVERSE);
					DrawPix(2*x+1,2*y+1,A_REVERSE);
				}
				A[y][x] = B[y][x];  //transfer the contents of B into A, so A can be edited
				B[y][x] = 0;  //clear B
			}
		}
		
	}//end while
}//end main
